<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG3</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG3 del grupo T2<br>
			Titulo: TG3. Implementar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Requisitos de los prototipos a implementar</a></li>
			<li><a href="#3">3. Criterios de comparacion de los prototipos</a></li>
			<li><a href="#4">4. Implementación del prototipo con tecnología A</a></li>
			<li><a href="#5">5. Implementación del prototipo con tecnología B</a></li>
			<li><a href="#6">6. Comparacion de los prototipos</a></li>
			<li><a href="#7">7. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
			<p>Grupo T2:</p>
			<p>Sergio Moreno Solera(Product Owner)</p>
			<p>Carlos Martínez Álvarez</p>
			<p>Miguel Galán Tabernero</p>
			<p>Joaquín Garín Garzón</p>
			<p>Aarón Jiménez Herráez</p>		
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<p>La URL del proyecto TG3 es:
				<a href="https://gitlab.com/dte2020/t2/tg3/">https://gitlab.com/dte2020/t2/tg3/</a>".</p>
			<h3>1.3 Burndown chart</h3>
			<img src="burndown-T2.JPG">
			<h3>1.4 Presentacion del trabajo</h3>

			<a href="T2-TG3.pptx">Presentacion con diapositivas del trabajo TG3</a></p>
		</section>
		<section id="2">
			<h2>2. Requisitos de los prototipos a implementar</h2>

			<h3>Catálogo de requisitos</h3>
				<table>
					<tr>
						<th>Req.</th>
						<th>Descripcion</th>
					</tr>
					<tr>
						<td>01</td>
						<td>El prototipo debe tener al menos 10 tipos diferentes de nodos.</td>
					</tr>
					<tr>
						<td>02</td>
						<td>El prototipo debe tener al menos 15 tipos distintos de enlaces.</td>
					</tr>
					<tr>
						<td>3</td>
						<td>Debe contar con al menos 20 nodos en total.</td>
					</tr>
					<tr>
						<td>4</td>
						<td>Tiene que tener como mínimo 30 relaciones de nodos.</td>
					</tr>
					<tr>
						<td>5</td>
						<td>Debe contar con adyacencia libre de índices (es una propiedad de las bases de datos basadas en grafos con capacidad de procesamiento nativo. En las bases de datos con esta propiedad, cada nodo mantiene un puntero directo a sus nodos adyacentes, de manera que cada nodo actúa como un pequeño índice de los nodos vecinos.).</td>
					</tr>
					<tr>
						<td>6</td>
						<td>Deben permitir la creación de restricciones de unicidad, para la fácil diferenciación de nombres entre los distintos nodos.</td>
					</tr>
				</table>
		
	
		</section>
		<section id="3">
			<h2>3. Criterios de comparacion de los prototipos.</h2>
			<h3>3.1 Criterio 1: Tipo de licencia</h3>
			<ul>
				<li>Nombre del criterio: Tipo de licencia</li>
				<li>Descripcion: Las licencias pueden ser de carácter comercial para vender y dar soporte a otras empresas o Open Source para utilizar el servicio de manera gratuita.</li>
				<li>Tipo de valor: String (comercial o libre)</li>
			</ul>
			<h3>3.2 Criterio 2: Sistemas operativos del servidor</h4>
				<ul>
					<li>Nombre del criterio: Sistemas operativos del servidor</li>
					<li>Descripcion: El prototipo puede ser soportado por un sistema operativo diferente, Linux, Os X, Windows o que esté alojado en el propio servidor.</li>
					<li>Tipo de valor: String (tipos de SO)</li>
				</ul>
			<h3>3.2 Criterio 3: Índices Secundarios</h4>
				<ul>
					<li>Nombre del criterio: Índices Secundarios</li>
					<li>Descripcion: Puede que el prototipo utilize algún índice secundario o no.</li>
					<li>Tipo de valor: boolean (índice secundario)</li>
				</ul>
			<h3>3.2 Criterio 4: Sistema con soporte en la nube</h4>
				<ul>
					<li>Nombre del criterio: Sistema con soporte en la nube</li>
					<li>Descripcion: El prototipo puede tener el servicio en la nube o hace falta descargar programas externos.</li>
					<li>Tipo de valor: boolean (nube)</li>
				</ul>
			<h3>3.2 Criterio 5: Lenguajes de programación soportados</h4>
				<ul>
					<li>Nombre del criterio: Lenguajes de programación soportados</li>
					<li>Descripcion: Tipos de lenguajes de programación que soporta el servicio.</li>
					<li>Tipo de valor: String (lenguajes)</li>
				</ul>
			<h3>3.2 Criterio 6: Concepto de transacciones</h4>
				<ul>
					<li>Nombre del criterio:  Concepto de transacciones</li>
					<li>Descripcion: Si garantiza o no el soporte para garantizar la integridad de los datos (ACID)</li>
					<li>Tipo de valor: boolean (ACID)</li>	
				</ul>
			<h3>3.2 Criterio 7: Concepto de consistencia</h4>
				<ul>
					<li>Nombre del criterio: Concepto de consistencia</li>
					<li>Descripcion: Métodos para garantizar la coherencia en un sistema distribuido, inmediata, causal, eventual ...</li>
					<li>Tipo de valor: String (método)</li>
			<h3>3.2 Criterio 8: Métodos de replicación</h4>
				<ul>
					<li>Nombre del criterio: Métodos de replicación</li>
					<li>Descripcion: Métodos para almacenar datos de forma redundante en múltiples nodos.</li>
					<li>Tipo de valor: String (método)</li>
			</ul>
		</section>

		<section id="4">
			<h2>4. Implementación del prototipo con Neo4j</h2>
			
			<p> Toda la documentación del prototipo A se encuentra en:
				<a
					href="https://gitlab.com/dte2020/t2/tg3/-/tree/master/prototipo-A/">https://gitlab.com/dte2020/t2/tg3/-/tree/master/prototipo-A/</a>.
			</p>
			<p>El prototipo A consiste en el diseño de una base de datos orientada a grafos. Dicho diseño se realizará con Neo4j, sistema gestor
				de bases de datos con el cual hemos trabajado.  </p>
			<p>El prototipo recoge datos de la red social Twitter y analiza la actividad de un subconjunto de usuarios.</p>
			<h3>4.1 Datos recogidos.</h3>
			<ul>
				<p>1. Usuarios de twitter</p>
				<p>2. Relaciones explicitas entre los usuarios</p>
				<p>3. Mensajes o tuits: En este apartado entran los tweets creados por el usuario, los 'retuits' y los 'replies'</p>
			</ul>
			

			<h3>4.2 Diseño conceptual.</h3>
			<p>Muestra la estructura que seguirá la base de datos que almacenará los datos de Twitter.
				<h4>Clases</h4>
				<ul>
					<li>Twitter User: todos los usuarios tienen un atributo 'userid' que los identifica dentro de la red.</li>
					<li>RelevantTwitterUser: usuarios con datos adicionales que los describen ('userName', 'screenName', 'location'...)
					<li>Language: idioma en el que se utilizará Twitter</li>
					<li>Tweet: tienen un conjunto de atributos como son: un identificador dentro de la red ('tweetID'), el texto del tweet ('text'), 
						fecha de creación ('createdAt') y una cadena con la aplicacioón emisora del tweet ('app')</li>
					<li>Retweet y Reply: se modelan como una especialización de la clase Tweet, contienen los atributos 'Retweeted' y 'Replied', respectivamente</li>
					<li>GeoLocatedTweet: especialización de Tweet para aquellos tuits que contienen datos de geolocalización, contiene los atributos 
						'longitude' y 'latitude'
					</li>
					<li>Location: localización en la que te encuentras; tiene como atributos 'locationID', 'fullName', 'name', 'type' y 'boundingBox'.</li>
				</ul>
				
			</p>
			<h3>4.3 Diseño lógico.</h3>
			<p>En el diseño lógico veremos como podemos modelar nuestra base de datos en forma de grafo. Para ello, debemos poner especial consideración a 
				los nodos, sus relaciones y propiedades.
				<ul>
					<li>Nodos: TwitterUser, RelevantTwitterUser, Tweet, Reply, Retweet, GeoLocatedTweet, Location, Language</li>
					<li>Relaciones: FOLLOWS, IS_WRITEN_FROM, HAS_A_PROFILE_LANGUAGE, HAS_WRITEN, IS_A_REPLY_OF, IS_A_RETWEET_OF</li>
					<li>Tipos de relaciones:
						<p>1. RelevantTwitterUser --- FOLLOWS --- TwitterUser</p>
						<p>2. GeoLocatedTweet --- IS_WRITEN_FROM --- Location</p>
						<p>3. RelevantTwitterUser --- HAS_A_PROFILE_LANGUAGE --- Language</p>
						<p>4. TwitterUser --- HAS_WRITEN --- Tweet</p>
						<p>5. Reply --- IS_A_REPLY_OF --- Tweet</p>
						<p>6.Retweet --- IS_A_RETWEET_OF --- Tweet</p>
					</li>
				</ul>
			</p>
			<h3>4.4 Diseño físico.</h3>	
			<p>en el diseño físico, creamos el grafo de propiedades del diseño lógico en una base de datos orientada a grafos,
				en nuestro caso neo4j.</p>
			<p>Para ello, debemos ir creando la base de datos en varias partes, es decir:</p>
			<ul>
				<li>1. Creación de la base de datos</li>
				<li>2. Creación de índices</li>
				<li>3. Creación de restricciones</li>
				<li>4. Transacciones</li>
			</ul>
					
			

			
		</section>


		<section id="5">
			<h2>5. Comparacion de los prototipos</h2>
			<p>Debe incluir al menos una tabla resumen cruzando los criterios y los
				valores de cada tecnología. Con una columna de comentarios sobre la comparación.</p>
			<table>
				<tr>
					<th>Criterio</th>
					<th>Prototipo Neo4j</th>
					<th>Prototipo Neptune</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>Tipo de licencia</td>
					<td>Libre</td>
					<td>Comercial</td>
					<td>Neo4j lo podemos implementar sin ningun problema sin embargo Neptune para realizar el prototipo
						requiere que introduzcas tu tarjeta de credito en el registro.</td>
				</tr>
				<tr>
					<td>Sistema operativo del servidor</td>
					<td>Windows,Linux,MAC</td>
					<td>Windows,Linux,MAC</td>
					<td>Ambos pemiten desarrollar el servidor en cualuqier sistema operativo.</td>
				</tr>
				<tr>
					<td>Indices secundarios</td>
					<td>Si</td>
					<td></td>
					<td>Neo4j nos permite utilizar indices secundarios a traves de sus etiquetas</td>
				</tr>
				<tr>
					<td>Servicio en la nube</td>
					<td>Si</td>
					<td></td>
					<td>Neo4j nos permite gestionar nuestra base de datos de grafos y reañizar modificaciones a traves de su servidor en la nube.</td>
				</tr>
				<tr>
					<td>Lenguajes de programacion</td>
					<td>Java, PHP, Ruby,.Net, Python, Node, Scala</td>
					<td></td>
					<td>Neo4j esta imlementado en java aunque permite trabajr con mas lenguajes.Nosotros hemos trabajado en java.</td>
				</tr>
				<tr>
					<td>Transacciones</td>
					<td>Si</td>
					<td></td>
					<td>Neo4j soporta transacciones ACID.</td>
				</tr>
				<tr>
					<td>Consistencia</td>
					<td>check-consistency</td>
					<td></td>
					<td>Neo4j nos permite ver la consistecncia de  nuestra base de datos con el comando check-consistency 'nombre base de datos'.</td>
				</tr>
				<tr>
					<td>Replicacion</td>
					<td>Si</td>
					<td></td>
					<td>Neo4j establece un sistema de replicacion maestro-esclavo dondo todos los nodos esclavos escriben para actualizar al maestro.</td>
				</tr>
			</table>
		</section>

		<section id="6">
			<h2>6. Conclusiones</h2>
			<p>Como conclusion de este trabajo hemos sacado que el uso comercial de una base de datos de grafos hace mas complejo su aprendizaje e implementación
				ya que al requerir introducir la tarjeta de credito en Neptune por si utilizabas alguna utilidad que costase dinero no nos ha permitido desarrolarlo.
				Sin embargo con Neo4j al ser totalmente gratuito nos ha permitido desarrollarlo con un sistema de ejemplo encontrado.
				Por lo que sobre nuestra experiencia  Neo4j sin duda es mejor sistema para el aprendizaje y la implementación de una base de datos de grafos, ya que también
				ofrece todo tipo de recuros para facilitar su implementación como gran disponibilidad de lenguajes de programción,
				estar disponible para varios SO y sobre todo cuenta con una muy amplia documentación sobre su uso e instalación.</p>
		</section>

		<p>(Hay que cumplir la estructura basica indicada de secciones. Pero si se desea se pueden añadir otras
			secciones como anexos. Por ejemplo, alguna encuesta de opinion realizada sobre las tecnologías, etc.)</p>

	</main>

</body>

</html>
